#include "StdInc.h"
#include "RollEmUpd.h"
#include "EditNote.h"
#include "Sound.h"

Boolean EditNoteProc (EventPtr event)
{
    FormPtr pForm;
    Int handled = 0;

	pForm = FrmGetActiveForm();
    switch (event->eType) 
    {
        case ctlSelectEvent:
		{
            switch (event->data.ctlEnter.controlID)
            {
				case IDC_BUTTON_TEST_SOUND:
				{
					FieldPtr pField;
					VoidHand hHertz, hDuration;
					CharPtr pHertz, pDuration;

					pField = FrmGetObjectPtr(pForm, FrmGetObjectIndex(pForm, IDC_HERTZ_FIELD));
					hHertz = (VoidHand)FldGetTextHandle(pField);
					pField = FrmGetObjectPtr(pForm, FrmGetObjectIndex(pForm, IDC_DURATION_FIELD));
					hDuration = (VoidHand)FldGetTextHandle(pField);
					PlayNote(StrAToL((CharPtr)MemHandleLock(hHertz)), StrAToL((CharPtr)MemHandleLock(hDuration)));
					MemHandleUnlock(hHertz);
					MemHandleUnlock(hDuration);
					handled = true;
					break;	
				}
			}
			break;
		}
	}

    return handled;
}

Word DoEditNote (NotePtr pNote)
{
	static Boolean bInit = false;
	FormPtr pForm, pOldForm;
	Word wResult;
	VoidHand hHertz, hDuration;
	CharPtr pHertz, pDuration;
	Char szTemp [32];

	wResult = 0;
	pOldForm = FrmGetActiveForm();
	if (pForm = FrmInitForm(IDF_EDIT_NOTE))
	{
		// Do the one time initialization 
		//  of the Sound dialog here.
		if (!bInit)
		{
			bInit = true;
		}

		// Do the every time initialization 
		//  of the Sound dialog here.
		hHertz = SetField (pForm, IDC_HERTZ_FIELD, 5, 
			StrLToA(szTemp, (Long)((pNote) ? pNote->uiHertz : 0)));
		hDuration = SetField (pForm, IDC_DURATION_FIELD, 5, 
			StrLToA(szTemp, (Long)((pNote) ? pNote->uiDuration : 0)));
		FrmSetFocus(pForm, FrmGetObjectIndex(pForm, IDC_HERTZ_FIELD));

		// Show the dialog.
		FrmSetEventHandler(pForm, (FormEventHandlerPtr) EditNoteProc);
		wResult = FrmDoDialog(pForm);

		if (wResult == IDC_OK)
		{
			pHertz = (CharPtr)MemHandleLock(hHertz);
			pDuration = (CharPtr)MemHandleLock(hDuration);
			if (StrAToL(pDuration) > 0)
			{
				if (pNote == 0)
				{
					Int iCount;

					iCount = GetNoteCount(g_iSoundSelect);
					AddNote(g_iSoundSelect, iCount, 0);
					GetNote(g_iSoundSelect, iCount, &pNote);
				}
				if (pNote)
				{
					pNote->uiHertz = StrAToL(pHertz);
					pNote->uiDuration = StrAToL(pDuration);
				}
			}
			MemHandleUnlock(hHertz);
			MemHandleUnlock(hDuration);
		}

		// We now return to our other window.
		if (pOldForm)
			FrmSetActiveForm(pOldForm);
		FrmDeleteForm(pForm);
	}

	return wResult;
}
