#ifndef __ROLLEMUPD_H
#define __ROLLEMUPD_H      1

#ifdef __cplusplus
extern "C" {
#endif

#define NOTE_A		440
#define NOTE_B		491
#define NOTE_C		527
#define NOTE_D		589
#define NOTE_E		658
#define NOTE_F		706
#define NOTE_G		788

#define ROLLEM_APPID			'RlEm'
#define ROLLEM_DBTYPE			'Data'

#define MAX_TITLE_LEN			15
#define MAX_TEMPSTRING_LEN		50

#define MIN_PAGES               1
#define MAX_PAGES               50

#define VERSION_NUMBER			110
#define DEFAULT_PAGES			5

#define IDC_BUTTON_FIRST        IDC_BUTTON_0
#define IDC_BUTTON_LAST         IDC_BUTTON_7
#define NUM_BUTTONS             ((IDC_BUTTON_LAST - IDC_BUTTON_FIRST) + 1)
#define ID2NUM(wId)             (wId - IDC_BUTTON_FIRST)
#define PAGE2REC101(wPage)		(wPage+1)
#define PAGE2REC110(wPage)		(wPage+10)
#define PREFS_RECORD			0
#define RESULTS_RECORD			1
#define SOUNDS_RECORD			2
#define ROLLS_RECORD			3

// ************************************************************* //
//                          Structures                           //
// ************************************************************* //

// Prefs
typedef struct _tagPrefs101
{
    Word wVersion;
    Word wCurrentPage;
    Word wTotalPages;
    Word wCurrentButton;
    Long lLastResult;
} Prefs101;
typedef Prefs101 *Prefs101Ptr;

typedef struct _tagPrefs110
{
    Word wVersion;
    Word wTotalPages;
} Prefs110;
typedef Prefs110 *Prefs110Ptr;

// Die rolls
typedef struct _tagDieRoll101
{
    Char szTitle [MAX_TITLE_LEN];
    Int iDie;
    Int iNumber;
    Int iModifier;
    Int iBest;
    Byte iBeepType1;
    Byte iBeepType2;
    Byte iBeepCompare1; 
    Byte iBeepCompare2; 
    Byte iSuccessCompare; 
    Long lBeepValue1;
    Long lBeepValue2;
    Long lSuccessValue;
} DieRoll101;
typedef DieRoll101 *DieRoll101Ptr;

typedef struct _tagDieRoll110
{ 
    Char szTitle [MAX_TITLE_LEN+1];
    Long lField00; //iDie
    Long lField01; //iNumber
    Long lField02; //iModifier
    Long lField03; //iBest
    Long lField04; //iBeepType1
    Long lField05; //iBeepType2
    Long lField06; //iBeepCompare1
    Long lField07; //iBeepCompare2
    Long lField08; //iSuccessCompare
    Long lField09; //lBeepValue1
    Long lField10; //lBeepValue2
    Long lField11; //lSuccessValue
    Long lField12; //lMisc
    Long lField13; //lMisc
    Long lField14; //lMisc
    Long lField15; //lMisc
    Long lField16; //lMisc
    Long lField17; //lMisc
    Long lField18; //lMisc
    Long lField19; //lMisc
    Long lField20; //lMisc
    Long lField21; //lMisc
    Long lField22; //lMisc
    Long lField23; //lMisc
    Long lField24; //lMisc
} DieRoll110;
typedef DieRoll110 *DieRoll110Ptr;

// Results
typedef struct _tagResults110
{
    Word wCurrentPage;
    Word wCurrentButton;
	Long lLastResult;
	Long lLastRolls [1];
} Results110;
typedef Results110 *Results110Ptr;

typedef struct _tagNote
{
    UInt uiHertz;
    UInt uiDuration;
} Note;
typedef Note *NotePtr;

typedef struct _tagNoteNode
{
	Note vNote;
	VoidPtr pNext;
} NoteNode;
typedef NoteNode *NoteNodePtr;

typedef struct _tagSound
{
	Char szTitle [MAX_TITLE_LEN + 1];
	NoteNode vNotes;
	UInt uiNotes;
} Sound;
typedef Sound *SoundPtr;

typedef struct _tagSoundNode
{
	Sound vSound;
	VoidPtr pNext;
} SoundNode;
typedef SoundNode *SoundNodePtr;

// ************************************************************* //
//                           Externs                             //
// ************************************************************* //

extern DmOpenRef g_hRollEmDB;

// ************************************************************* //
//                     Forward Declarations                      //
// ************************************************************* //

#ifdef __cplusplus
}
#endif

#endif
